//+------------------------------------------------------------------+
//|                                            TsaktuoDealServer.mq5 |
//|                                                          tsaktuo |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "tsaktuo"
#property link      "http://www.mql5.com"
#property version   "1.00"

//--- definitions
#define DEAL_ENTRY_OUTALL 5

#import "SocketServer.dll" //    C#    ,
                           //    http://www.mql5.com/ru/articles/249
string About();            //   
int SendToAll(string msg); //      
bool Stop();               //  
bool StartListen(int port);//  .      (. 500 ).
                           //      
string ReadLogLine();      //      (   ). 
                           //      100  .
#import
//+------------------------------------------------------------------+
//|                                                       |
//+------------------------------------------------------------------+
enum ENUM_STARTUP_TYPE
  {
   STARTUP_TYPE_CLEAR,    // CLEAR -    ,    (Send every new DEAL wich appears on account).
   STARTUP_TYPE_CONTINUE  // CONTINUE -        (Do not send DEAL before existing POSITION has been closed).
  };
//---  
input int               InpPort=2011;                         //  
input ENUM_STARTUP_TYPE InpStartupType=STARTUP_TYPE_CONTINUE; //  
//---  
datetime g_dtLastDealTime=0;
string g_sSymbolsToIgnore[];
//+------------------------------------------------------------------+
//|    C#  MQL5                               |
//+------------------------------------------------------------------+
string UTF8_to_ASCII(string utf8)
  {
   string retval="";
   for(int i=0;i<StringLen(utf8);i++)
     {
      ushort val=StringGetCharacter(utf8,i);
      if(val==0xFF00)break;

      retval+=CharToString((char)(val&0x00FF));
      retval+=CharToString((char)((val&0xFF00)>>8));
     }
   return retval;
  }
//+------------------------------------------------------------------+
//|   ENUM_DEAL_TYPE                |
//+------------------------------------------------------------------+
string Type2String(ENUM_DEAL_TYPE type)
  {
   switch(type)
     {
      case DEAL_TYPE_BUY:return "BUY";
      case DEAL_TYPE_SELL:return "SELL";
     }
   return "";
  }
//+------------------------------------------------------------------+
//|  ENUM_DEAL_ENTRY + my DEAL_ENTRY_OUTALL     |
//+------------------------------------------------------------------+
string Entry2String(int entry)
  {
   switch(entry)
     {
      case DEAL_ENTRY_IN:return "IN";
      case DEAL_ENTRY_OUT:return "OUT";
      case DEAL_ENTRY_INOUT:return "INOUT";
      case DEAL_ENTRY_OUTALL:return "OUTALL";
      case DEAL_ENTRY_STATE:return "STATE";
     }
   return "";
  }
//+------------------------------------------------------------------+
//|  ,          |
//+------------------------------------------------------------------+
bool bIsThisSymbolEnabled(string symbol)
  {
//---    ,     OnInit()
   for(int i=0;i<ArraySize(g_sSymbolsToIgnore);i++)
     {
      //---     ,  false
      if(g_sSymbolsToIgnore[i]==symbol)
         return false;
     }
   return true;
  }
//+------------------------------------------------------------------+
//|                                |
//+------------------------------------------------------------------+
void vUpdateEnabledSymbols()
  {
//---    go   
//---          
   for(int i=0;i<ArraySize(g_sSymbolsToIgnore);i++)
     {
      //---      ...
      if(!PositionSelect(g_sSymbolsToIgnore[i]))
        {
         //---   -    
         g_sSymbolsToIgnore[i]="";
        }
     }
  }
//+------------------------------------------------------------------+
//| Enable requested symbol. This function is used in case when INOUT|
//| DEAL is executed - we dont want to know about OUT but we need to |
//| know about IN.                                                   |
//+------------------------------------------------------------------+
void vEnableSymbol(string symbol)
  {
//---     ,      ,
//---    
   for(int i=0;i<ArraySize(g_sSymbolsToIgnore);i++)
     {
      //---   ...
      if(g_sSymbolsToIgnore[i]==symbol)
        {
         //---   -     .
         g_sSymbolsToIgnore[i]="";
         Print("Symbol ",symbol," enabled for traiding.");
        }
     }
  }
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   string str="";
   Print(UTF8_to_ASCII(About()));
//---  
   Print("Starting server on port ",InpPort,"...");
   if(!StartListen(InpPort))
     {
      PrintLogs();
      Print("OnInit() - FAILED");
      return -1;
     }
//---    
   PrintLogs();
//--- -24  -   'g_dtLastDealTime'
   datetime dtStart=TimeCurrent()-60*60*24;
//--- +24  (    GMT-<hours>)
   datetime dtEnd=TimeCurrent()+60*60*24;

   HistorySelect(dtStart,dtEnd);
   for(int i=0;i<HistoryDealsTotal();i++)
     {
      ulong ticket=HistoryDealGetTicket(i);
      if(HistoryDealGetInteger(ticket,DEAL_ENTRY)!=DEAL_ENTRY_STATE)
        {
         if(HistoryDealGetInteger(ticket,DEAL_TIME)>g_dtLastDealTime)
           {
            g_dtLastDealTime=(datetime)HistoryDealGetInteger(ticket,DEAL_TIME);
           }
        }
     }
   if(InpStartupType==STARTUP_TYPE_CONTINUE)
     {
      //---       
      //---         
      //---           
      for(int i=0;i<PositionsTotal();i++)
        {
         //---     1
         ArrayResize(g_sSymbolsToIgnore,ArraySize(g_sSymbolsToIgnore)+1);
         //---   
         g_sSymbolsToIgnore[ArraySize(g_sSymbolsToIgnore)-1]=PositionGetSymbol(i);
         Print("Symbol ",g_sSymbolsToIgnore[ArraySize(g_sSymbolsToIgnore)-1]," disable till position is reopened.");
        }
     }
//---    OnTimer()  1 .
   EventSetTimer(1);
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---  
   EventKillTimer();
//---  
   Stop();
//---   
   PrintLogs();
   Print("Deinit done.");
  }
//+------------------------------------------------------------------+
//| OnTrade() -                   |
//+------------------------------------------------------------------+
void OnTrade()
  {
//---          
//--- -24 
   datetime dtStart=TimeCurrent()-60*60*24;
//--- +24  (   -<hours>)
   datetime dtEnd=TimeCurrent()+60*60*24;
//---      
   if(HistorySelect(dtStart,dtEnd))
     {
      //---     (   )
      for(int i=0;i<HistoryDealsTotal();i++)
        {
         //---   
         ulong ticket=HistoryDealGetTicket(i);
         //--- if this deal is interesting for us.
         if(HistoryDealGetInteger(ticket,DEAL_ENTRY)!=DEAL_ENTRY_STATE)
           {
            //Print("Entry type ok.");
            //--- ,      ,      
            if(HistoryDealGetInteger(ticket,DEAL_TIME)>g_dtLastDealTime)
              {
               //---    ,    
               if(HistoryDealGetInteger(ticket,DEAL_ENTRY)==DEAL_ENTRY_OUT)
                 {
                  vUpdateEnabledSymbols();
                 }
               //---      ,    
               else if(HistoryDealGetInteger(ticket,DEAL_ENTRY)==DEAL_ENTRY_INOUT)
                 {
                  //---   
                  vEnableSymbol(HistoryDealGetString(ticket,DEAL_SYMBOL));
                 }
               //---     
               if(bIsThisSymbolEnabled(HistoryDealGetString(ticket,DEAL_SYMBOL)))
                 {
                  //---          
                  int cnt=SendToAll(sBuildDealString(ticket));
                  //---    .
                  if(cnt<0)
                    {
                     Print("Failed to send new deals!");
                    }
                  //---     (cnt==0)   -  (cnt>0)                  
                  else
                    {
                     //---    
                     g_dtLastDealTime=(datetime)HistoryDealGetInteger(ticket,DEAL_TIME);
                    }
                 }
               //---   ,     
               else
                 {
                  //---    ,      
                  g_dtLastDealTime=(datetime)HistoryDealGetInteger(ticket,DEAL_TIME);
                 }
              }
           }
        }
     }
  }
//+------------------------------------------------------------------+
//|                        |
//| :                                                         |
//| EURUSD;BUY;IN;0.01;1.37294                                       |
//| EURUSD;SELL;OUT;0.01;1.37310                                     |
//| EURUSD;SELL;IN;0.01;1.37320                                      |
//| EURUSD;BUY;INOUT;0.02;1.37294                                    |
//+------------------------------------------------------------------+
string sBuildDealString(ulong ticket)
  {
   string deal="";
   double volume=0;
   bool bFirstInOut=true;
//---   
//---     INOUT
   if(HistoryDealGetInteger(ticket,DEAL_ENTRY)==DEAL_ENTRY_INOUT)
     {
      if(PositionSelect(HistoryDealGetString(ticket,DEAL_SYMBOL)))
        {
         volume=PositionGetDouble(POSITION_VOLUME);
        }
      else
        {
         Print("Failed to get volume!");
        }
     }
//---   'IN'  'OUT',    
   else
     {
      volume=HistoryDealGetDouble(ticket,DEAL_VOLUME);
     }
//---   (: "<EURUSD;BUY;IN;0.01;1.37294>").
   int iDealEntry=(int)HistoryDealGetInteger(ticket,DEAL_ENTRY);
//---    OUT     
   if(iDealEntry==DEAL_ENTRY_OUT && !PositionSelect(HistoryDealGetString(ticket,DEAL_SYMBOL)))
     {
      //---     ,      .  ,  
      //---     - OUTALL.   ,       
      //---     "" .     
      //---     ,        ,  
      //---      .
      //---    (    ENUM_DEAL_ENTRY).
      iDealEntry=DEAL_ENTRY_OUTALL;  
     }
   StringConcatenate(deal,"<",AccountInfoInteger(ACCOUNT_LOGIN),";",HistoryDealGetString(ticket,DEAL_SYMBOL),";",Type2String((ENUM_DEAL_TYPE)HistoryDealGetInteger(ticket,DEAL_TYPE)),";",Entry2String(iDealEntry),";",DoubleToString(volume,2),";",DoubleToString(HistoryDealGetDouble(ticket,DEAL_PRICE),(int)SymbolInfoInteger(HistoryDealGetString(ticket,DEAL_SYMBOL),SYMBOL_DIGITS)),">");
   Print("DEAL:",deal);
   return deal;
  }
//+------------------------------------------------------------------+
//|      (  )       |
//+------------------------------------------------------------------+
void OnTimer()
  {
   PrintLogs();
  }
//+------------------------------------------------------------------+
//|                |
//+--------------------------------------------------------------------+
void PrintLogs()
  {
   string line="";
   do
     {
      //--- getting log line and prints it out.
      line=UTF8_to_ASCII(ReadLogLine());
      if(StringLen(line)>0)
        {
         Print(line);
        }
     }
   while(StringLen(line)>0);
  }
//+------------------------------------------------------------------+
